<template>
  <b-container>
    <div class="pageTitle">
      <h1>
        <b-icon-calendar-2-plus />
        Nova Consulta
      </h1>
    </div>
    <b-alert :show="alertShow" :variant="alertVariant">{{ alertMessage }}</b-alert>
    <b-card class="create">
      <validation-observer ref="observer" v-slot="{ handleSubmit }">
        <b-form @submit.stop.prevent="handleSubmit(submitCreate)">
          <b-row>
            <b-col xs="12" md="4">
              <validation-provider rules="required" v-slot="v" name="Data da Consulta">
                <b-form-group
                  label="Data da Consulta"
                  label-for="create-datepicker"
                >
                  <b-form-datepicker 
                    id="create-datepicker" 
                    locale="pt-BR"
                    placeholder="Insira uma data"
                    label-no-date-selected="Sem data escolhida"
                    v-model="date"
                    :disabled="loading"
                    :min="minDate" 
                    :state="getValidationState(v)"
                    :date-format-options="{ 
                      year: 'numeric', 
                      month: 'numeric', 
                      day: 'numeric' 
                    }"
                    reset-button
                  />
                  <b-form-invalid-feedback>{{ v.errors[0] }}</b-form-invalid-feedback>
                </b-form-group>
              </validation-provider>
            </b-col>
            <b-col xs="12" md="4">
              <validation-provider rules="required" v-slot="v" name="Hora da Consulta">
                <b-form-group
                  label="Hora da Consulta"
                  label-for="create-timepicker"
                >
                  <b-form-timepicker
                    id="create-timepicker"
                    locale="pt-BR"
                    placeholder="Insira um horário"
                    label-no-time-selected="Sem hora definida"
                    v-model="time"
                    :disabled="loading"
                    :state="getValidationState(v)"
                    reset-button
                  />
                  <b-form-invalid-feedback>{{ v.errors[0] }}</b-form-invalid-feedback>
                </b-form-group>
              </validation-provider>
            </b-col>
            <b-col xs="12" md="4">
              <validation-provider rules="required" v-slot="v" name="Médico">
                <b-form-group
                  label="Médico"
                  label-for="create-doctor"
                >
                  <b-form-select
                    id="create-doctor"
                    v-model="doctorId"
                    :options="doctorList"
                    :disabled="loading"
                    :state="getValidationState(v)"
                  />
                  <b-form-invalid-feedback>{{ v.errors[0] }}</b-form-invalid-feedback>
                </b-form-group>
              </validation-provider>
            </b-col>
            <b-col xs="12" md="12">
              <validation-provider rules="required" v-slot="v" name="Paciente">
                <b-form-group
                  label="Paciente"
                  label-for="create-pacient"
                >
                  <b-form-input 
                    id="create-pacient"
                    type="text"
                    placeholder="Insira o nome do paciente"
                    v-model="pacient"
                    :disabled="loading"
                    :state="getValidationState(v)"
                    trim
                  />
                  <b-form-invalid-feedback>{{ v.errors[0] }}</b-form-invalid-feedback>
                </b-form-group>
              </validation-provider>
            </b-col>
            <b-col xs="12" md="12">
              <validation-provider rules="required" v-slot="v" name="Observação">
                <b-form-group
                  label="Observação"
                  label-for="create-obs"
                >
                  <b-form-textarea 
                    id="create-obs"
                    placeholder="Insira alguma informação pertinente sobre o paciente ou consulta"
                    v-model="observation"
                    :disabled="loading"
                    :state="getValidationState(v)"
                    rows="5"
                    no-resize
                    trim
                  />
                  <b-form-invalid-feedback>{{ v.errors[0] }}</b-form-invalid-feedback>
                </b-form-group>
              </validation-provider>
            </b-col>
            <b-col xs="12" md="12">
              <b-button 
                type="submit"
                class="submitButton"
                :disabled="loading"
                :variant="loading ? 'secondary' : 'primary'" 
                squared
              >
                <b-spinner 
                  v-if="loading"
                  variant="light"
                  small
                />
                {{ loading ? 'Enviando informações' : 'Criar Consulta' }}
              </b-button>
            </b-col>
          </b-row>
        </b-form>
      </validation-observer>
    </b-card>
  </b-container>
</template>

<script>
import { mapActions } from "vuex";
import { ValidationProvider, ValidationObserver, extend } from "vee-validate";
import { required } from "vee-validate/dist/rules";

import moment from 'moment-timezone'

extend('required', required)

export default {
  components: {
    ValidationProvider,
    ValidationObserver
  },

  computed: {
    dateTime() {
      return moment(`${this.date}T${this.time}`).format('DD/MM/YYYY HH:mm')
    }
  },

  methods: {
    ...mapActions('appointment', ['createAppointment']),
    getValidationState ({ dirty, validated, valid = null }) {
      return dirty || validated ? valid : null
    },

    toggleAlert (message, variant) {
      this.alertMessage = message
      this.alertVariant = variant

      setTimeout(() => {
        this.alertShow = true
      }, 100)
    },

    resetForm() {
      this.date = ''
      this.time = ''
      this.pacient = ''
      this.observation = ''
      this.doctorId = null

      this.$nextTick(() => this.$refs.observer.reset())
    },

    async submitCreate() {
      this.alertShow = false
      this.loading = true

      const appointmentDate = moment(`${this.date}T${this.time}`).format('DD/MM/YYYY HH:mm')
      const {
        pacient,
        observation,
        doctorId
      } = this

      const { success, message } = await this.createAppointment({
        appointmentDate,
        pacient,
        observation,
        doctorId
      })

      this.loading = false
      
      this.toggleAlert(message, success ? 'success' : 'danger')

      if (success) {
        this.resetForm()
      }
    }
  },

  data() {
    return {
      date: '',
      time: '',
      pacient: '',
      observation: '',
      doctorId: null,

      loading: false,
      alertMessage: '',
      alertShow: false,
      alertVariant: 'secondary',

      minDate: moment().format('YYYY-MM-DD'),
      doctorList: [
        { text: 'Escolha um médico', value: null },
        { text: 'Dr. Daniel Vieira', value: 1 },
      ]
    }
  }
}
</script>